Browse Source

first commit

Votre Nom 2 years ago
commit
7a8c86c8e0
4 changed files with 422 additions and 0 deletions
  1. 196 0
      001.openwrt_cgminer_patch
  2. 220 0
      build-gekko_new.sh
  3. BIN
      odhcpd.tar.xz
  4. 6 0
      prereq.sh

+ 196 - 0
001.openwrt_cgminer_patch

@@ -0,0 +1,196 @@
+diff --git a/dragonmint_t1.c "b/dragonmint_t1.c"
+index 9241073..44cd096 100644
+--- a/dragonmint_t1.c
++++ "b/dragonmint_t1.c"
+@@ -11,7 +11,7 @@
+ #include <assert.h>
+ #include <fcntl.h>
+ #include <limits.h>
+-#include <unistd.h>
++//#include <unistd.h> //openwrt mod//
+ #include <stdbool.h>
+ 
+ #include "logging.h"
+diff --git a/driver-avalon.c "b/driver-avalon.c"
+index 2210130..4ed159b 100644
+--- a/driver-avalon.c
++++ "b/driver-avalon.c"
+@@ -19,7 +19,7 @@
+ #include <sys/types.h>
+ #include <ctype.h>
+ #include <dirent.h>
+-#include <unistd.h>
++//#include <unistd.h> //mod openwrt//
+ #include <time.h>
+ #ifndef WIN32
+   #include <sys/select.h>
+diff --git a/diver-avalon2.c "b/driver-avalon2.c"
+index c3fa18a..738a775 100644
+--- a/driver-avalon2.c
++++ "b/driver-avalon2.c"
+@@ -18,7 +18,7 @@
+ #include <sys/time.h>
+ #include <sys/types.h>
+ #include <dirent.h>
+-#include <unistd.h>
++//#include <unistd.h> //openwrt/mod
+ #ifndef WIN32
+   #include <termios.h>
+   #include <sys/stat.h>
+diff --git a/driver-bflsc.c "b/driver-bflsc.c"
+index ce17555..50be2f5 100644
+--- a/driver-bflsc.c
++++ "b/driver-bflsc.c"
+@@ -18,7 +18,7 @@
+ #include <string.h>
+ #include <strings.h>
+ #include <sys/time.h>
+-#include <unistd.h>
++//#include <unistd.h> //openwrt mod//
+ 
+ #include "compat.h"
+ #include "miner.h"
+diff --git a/driver-bitforce.c "b/driver-bitforce.c"
+index e8a912b..cb91173 100644
+--- a/driver-bitforce.c
++++ "b/driver-bitforce.c"
+@@ -17,7 +17,7 @@
+ #include <stdio.h>
+ #include <strings.h>
+ #include <sys/time.h>
+-#include <unistd.h>
++//#include <unistd.h> // openwrt mod//
+ 
+ #include "compat.h"
+ #include "miner.h"
+diff --git a/driver-blockerupter.c "b/driver-blockerupter.c"
+index 734dd14..c3c2a27 100644
+--- a/driver-blockerupter.c
++++ "b/driver-blockerupter.c"
+@@ -5,7 +5,7 @@
+ #include <sys/time.h>
+ #include <sys/types.h>
+ #include <dirent.h>
+-#include <unistd.h>
++//#include <unistd.h> //openwrt mod//
+ #include <math.h>
+ #ifndef WIN32
+ #include <termios.h>
+diff --git a/driver-btm-soc.c "b/driver-btm-soc.c"
+index 3d439b4..7c22ddc 100644
+--- a/driver-btm-soc.c
++++ "b/driver-btm-soc.c"
+@@ -16,7 +16,8 @@
+ #include <sys/time.h>
+ #include <sys/types.h>
+ #include <dirent.h>
+-#include <unistd.h>
++//#include <unistd.h> //openwrt mod//
++
+ #include <sys/mman.h>
+ #include <math.h>
+ 
+diff --git a/driver-gekko.c "b/driver-gekko.c"
+index c41a081..478284f 100644
+--- a/driver-gekko.c
++++ "b/driver-gekko.c"
+@@ -12,7 +12,7 @@
+ #include "driver-gekko.h"
+ #include "crc.h"
+ #include "compat.h"
+-#include <unistd.h>
++//#include <unistd.h> //openwrt mod//
+ 
+ #ifdef __GNUC__
+ #if __GNUC__ >= 7
+diff --git a/driver-icarus.c "b/driver-icarus.c"
+index 0a20c63..d295239 100644
+--- a/driver-icarus.c
++++ "b/driver-icarus.c"
+@@ -37,7 +37,7 @@
+ #include <stdio.h>
+ #include <strings.h>
+ #include <sys/time.h>
+-#include <unistd.h>
++//#include <unistd.h> // openwrt mod //
+ #include <math.h>
+ 
+ #include "config.h"
+diff --git a/driver-klondike.c "b/driver-klondike.c"
+index 61981d8..648e1e6 100644
+--- a/driver-klondike.c
++++ "b/driver-klondike.c"
+@@ -16,7 +16,7 @@
+ #include <stdio.h>
+ #include <strings.h>
+ #include <sys/time.h>
+-#include <unistd.h>
++//#include <unistd.h> //openwrt mod//
+ #include <math.h>
+ 
+ #include "config.h"
+diff --git a/driver-knc.c "b/driver-knc.c"
+index 564d27d..34d1989 100644
+--- a/driver-knc.c
++++ "b/driver-knc.c"
+@@ -13,7 +13,7 @@
+ #include <assert.h>
+ #include <fcntl.h>
+ #include <limits.h>
+-#include <unistd.h>
++//#include <unistd.h> //openwrt mod//
+ #include <sys/ioctl.h>
+ #include <sys/time.h>
+ #include <linux/types.h>
+diff --git a/driver-modminer.c "b/driver-modminer.c"
+index d3dd946..8094246 100644
+--- a/driver-modminer.c
++++ "b/driver-modminer.c"
+@@ -12,7 +12,7 @@
+ 
+ #include <stdarg.h>
+ #include <stdio.h>
+-#include <unistd.h>
++//#include <unistd.h> //openwrt mod//
+ #include <math.h>
+ 
+ #include "logging.h"
+diff --git a/driver-spondoolies-sp10.c "b/driver-spondoolies-sp10.c"
+index c2a983a..9a0f115 100644
+--- a/driver-spondoolies-sp10.c
++++ "b/driver-spondoolies-sp10.c"
+@@ -23,7 +23,7 @@
+ #include <stdio.h>
+ #include <strings.h>
+ #include <sys/time.h>
+-#include <unistd.h>
++//#include <unistd.h> //openwrt mod//
+ #include <assert.h>
+ #include <time.h>
+ #include <sys/socket.h>
+diff --git a/driver-spondoolies-sp30.c "b/driver-spondoolies-sp30.c"
+index 1a71d12..b0bdb25 100644
+--- a/driver-spondoolies-sp30.c
++++ "b/driver-spondoolies-sp30.c"
+@@ -23,7 +23,7 @@
+ #include <stdio.h>
+ #include <strings.h>
+ #include <sys/time.h>
+-#include <unistd.h>
++//#include <unistd.h> //openwrt mod//
+ #include <assert.h>
+ #include <time.h>
+ #include <sys/socket.h>
+diff --git a/usbutils.c "b/usbutils.c"
+index d6c9ad6..ff3ad1e 100644
+--- a/usbutils.c
++++ "b/usbutils.c"
+@@ -4112,7 +4112,7 @@ void usb_initialise(void)
+ 
+ #ifndef WIN32
+ #include <errno.h>
+-#include <unistd.h>
++//#include <unistd.h> //openwrt mod//
+ #include <sys/stat.h>
+ #include <sys/file.h>
+ #include <fcntl.h>

+ 220 - 0
build-gekko_new.sh

@@ -0,0 +1,220 @@
+#!/bin/bash
+# This is a script for build avalon controller image
+#
+#  Copyright 2014-2015 Mikeqin <Fengling.Qin@gmail.com>
+#  Copyright 2012-2015 Xiangfu <xiangfu@openmobilefree.com>
+#
+# OPENWRT_DIR is ${ROOT_DIR}/openwrt, build the image in it
+# Controller's image should include the following configurations:
+#    ${AVA_MACHINE}_owrepo : OpenWrt repo, format: repo_url@repo_ver
+#    feeds.${AVA_MACHINE}.conf : OpenWrt feeds, file locate in cgminer-openwrt-packages
+#    ${AVA_TARGET_BOARD}_brdcfg : OpenWrt target and config, file locate in cgminer-openwrt-packages
+#
+# Learn bash: http://explainshell.com/
+set -e
+
+SCRIPT_VERSION=30092017
+
+# Support machine: avalon6, avalon4
+[ -z "${AVA_MACHINE}" ] && AVA_MACHINE=gekko
+
+# Support target board: rpi2-modelb, rpi1-modelb, tl-wr703n-v1, tl-mr3020-v1
+[ -z "${AVA_TARGET_BOARD}" ] && AVA_TARGET_BOARD=tl-mr3020-v1
+
+# OpenWrt repo
+#avalon4_owrepo="svn://svn.openwrt.org/openwrt/trunk@43076"
+#avalon6_owrepo="git://git.openwrt.org/15.05/openwrt.git@master"
+avalon4_owrepo="svn://svn.openwrt.org/openwrt/trunk@43076"
+avalon6_owrepo="git://git.openwrt.org/openwrt.git@cac971da"
+gekko_owrepo="http://gogserver.dnsalias.com:3000/wareck/openwrt_chaos_calmer.git@master"
+
+# OpenWrt feeds
+FEEDS_CONF=feeds.${AVA_MACHINE}.conf
+
+# Board config: target(get it in the OpenWrt bin), config
+rpi2_modelb_brdcfg=("brcm2708" "config.${AVA_MACHINE}.rpi2")
+rpi1_modelb_brdcfg=("brcm2708" "config.${AVA_MACHINE}.raspberry-pi")
+tl_wr703n_v1_brdcfg=("ar71xx" "config.${AVA_MACHINE}.703n")
+tl_mr3020_v1_brdcfg=("ar71xx" "config.${AVA_MACHINE}.mr3020")
+
+which wget > /dev/null && DL_PROG=wget && DL_PARA="-nv -O"
+which curl > /dev/null && DL_PROG=curl && DL_PARA="-L -o"
+
+# According to http://wiki.openwrt.org/doc/howto/build
+unset SED
+unset GREP_OPTIONS
+[ "`id -u`" == "0" ] && echo "[ERROR]: Please use non-root user" && exit 1
+# Adjust CORE_NUM by yourself
+[ -z "${CORE_NUM}" ] && CORE_NUM="$(expr $(nproc) + 1)"
+DATE=`date +%Y%m%d`
+SCRIPT_FILE="$(readlink -f $0)"
+SCRIPT_DIR=`dirname ${SCRIPT_FILE}`
+ROOT_DIR=${SCRIPT_DIR}/avalon
+OPENWRT_DIR=${ROOT_DIR}/openwrt
+
+prepare_version() {
+    cd ${OPENWRT_DIR}
+    GIT_VERSION=`git ls-remote https://github.com/wareck/cgminer-gekko master | cut -f1 | cut -c1-7`
+    LUCI_GIT_VERSION=`git --git-dir=./feeds/luci/.git rev-parse HEAD | cut -c1-7`
+    OW_GIT_VERSION=`git --git-dir=./feeds/cgminer/.git rev-parse HEAD | cut -c1-7`
+
+cat > ./files/etc/avalon_version << EOL
+Firmware - $DATE
+luci: $LUCI_GIT_VERSION
+cgminer: $GIT_VERSION
+cgminer-packages: $OW_GIT_VERSION
+EOL
+}
+
+prepare_patch() {
+	echo "patching"
+	cd ${OPENWRT_DIR}
+	cd /home/wareck/avalon/openwrt/build_dir/target-mips_34kc_uClibc-0.9.33.2/cgminer-git-$GIT_VERSION
+	cp /home/wareck/001.openwrt_cgminer_patch .
+	patch -p1 < 001.openwrt_cgminer_patch
+}
+
+
+prepare_config() {
+    cd ${OPENWRT_DIR}
+    eval OPENWRT_CONFIG=\${"`echo ${AVA_TARGET_BOARD//-/_}`"_brdcfg[1]} && cp ./feeds/cgminer/cgminer/data/${OPENWRT_CONFIG} .config
+}
+
+prepare_feeds() {
+    cd ${OPENWRT_DIR}
+    $DL_PROG https://raw.github.com/wareck/gekko-openwrt-packages/master/cgminer/data/${FEEDS_CONF} $DL_PARA feeds.conf && \
+    ./scripts/feeds update -a && \
+    ./scripts/feeds install -a
+
+    if [ ! -e files ]; then
+        ln -s feeds/cgminer/cgminer/root-files files
+    fi
+}
+
+prepare_source() {
+    echo "Gen firmware for ${AVA_TARGET_BOARD}:${AVA_MACHINE}"
+    cd ${SCRIPT_DIR}
+    [ ! -d avalon ] && mkdir -p avalon/bin
+    cd avalon
+    if [ ! -d openwrt ]; then
+        eval OPENWRT_URL=\${${AVA_MACHINE}_owrepo}
+        PROTOCOL="`echo ${OPENWRT_URL} | cut -d : -f 1`"
+
+        case "${PROTOCOL}" in
+            git)
+                GITBRANCH="`echo ${OPENWRT_URL} | cut -d @ -f 2`"
+                GITREPO="`echo ${OPENWRT_URL} | cut -d @ -f 1`"
+                git clone -b ${GITBRANCH} ${GITREPO} openwrt
+                ;;
+            svn)
+                SVNVER="`echo ${OPENWRT_URL} | cut -d @ -f 2`"
+                SVNREPO="`echo ${OPENWRT_URL} | cut -d @ -f 1`"
+                svn co ${SVNREPO}@${SVNVER} openwrt
+                ;;
+	    http)
+                GITBRANCH="`echo ${OPENWRT_URL} | cut -d @ -f 2`"
+                GITREPO="`echo ${OPENWRT_URL} | cut -d @ -f 1`"
+                git clone ${GITREPO} openwrt
+                ;;
+
+            *)
+                echo "Protocol not supported"; exit 1;
+                ;;
+        esac
+    fi
+    [ ! -e dl ] && mkdir dl
+    cd ${OPENWRT_DIR}
+    ln -sf ../dl
+}
+
+build_image() {
+    cd ${OPENWRT_DIR}
+    yes "" | make oldconfig > /dev/null
+    # clean before build
+    make -j${CORE_NUM} clean world
+    #make -j${CORE_NUM} world V=s
+
+}
+
+build_cgminer() {
+    cd ${OPENWRT_DIR}
+    rm -f ./dl/cgminer-*.tar.bz2
+    yes "" | make oldconfig > /dev/null
+    patch -p0 </home/wareck/001.openwrt_cgminer_patch
+    make -j${CORE_NUM} package/cgminer/{clean,compile}
+    if [ "$?" == "0" ]; then
+        eval AVA_TARGET_PLATFORM=\${"`echo ${AVA_TARGET_BOARD//-/_}`"_brdcfg[0]}
+        cd ..
+        mkdir -p ./bin/${AVA_TARGET_BOARD}
+        cp ./openwrt/bin/${AVA_TARGET_PLATFORM}/packages/cgminer/cgminer*.ipk  ./bin/${AVA_TARGET_BOARD}
+    fi
+}
+
+do_release() {
+    cd ${ROOT_DIR}
+    eval AVA_TARGET_PLATFORM=\${"`echo ${AVA_TARGET_BOARD//-/_}`"_brdcfg[0]}
+    mkdir -p ./bin/${DATE}/${AVA_TARGET_BOARD}/
+    cp -a ./openwrt/bin/${AVA_TARGET_PLATFORM}/* ./bin/${DATE}/${AVA_TARGET_BOARD}/
+}
+
+cleanup() {
+    cd ${ROOT_DIR}
+    rm -rf openwrt/ > /dev/null
+}
+
+show_help() {
+    echo "\
+Usage: $0 [--version] [--help] [--build] [--cgminer] [--cleanup]
+
+     --version
+     --help             Display help message
+     --build            Get .config file and build firmware
+     --cgminer          Re-compile only cgminer openwrt package
+     --test		Dowload and prebuild files
+     --cleanup          Remove all files
+
+     AVA_TARGET_BOARD   Environment variable, available target:
+                        tl-wr703n-v1, pi-modelb-v1
+                        pi-modelb-v2, tl-mr3020-v1
+                        use pi-modelb-v2 if unset
+
+     AVA_MACHINE        Environment variable, available machine:
+                        avalon6, avalon4, gekko, rockminer
+                        use avalon6 if unset
+
+Written by: Xiangfu <xiangfu@openmobilefree.net>
+            Fengling <Fengling.Qin@gmail.com>
+	    wareck <wareck@gmail.com>
+                                                     Version: ${SCRIPT_VERSION}"
+ }
+
+if [ "$#" == "0" ]; then
+    $0 --help
+    exit 0
+fi
+
+for i in "$@"
+do
+    case $i in
+        --version|--help)
+            show_help
+            exit
+            ;;
+        --build)
+            prepare_source && prepare_feeds && prepare_config && prepare_version && build_image && do_release
+            ;;
+        --cgminer)
+            prepare_source && prepare_feeds && prepare_config && prepare_version && build_cgminer
+            ;;
+	--test)
+	    prepare_source && prepare_feeds && prepare_config && prepare_version
+	    ;;
+        --cleanup)
+            cleanup
+            ;;
+        *)
+            show_help
+            exit
+            ;;
+    esac
+done

BIN
odhcpd.tar.xz


+ 6 - 0
prereq.sh

@@ -0,0 +1,6 @@
+#!/bin/bash
+sudo apt-get update
+sudo apt-get install subversion git curl python3 gettext
+sudo apt-get install subversion mercurial
+sudo apt-get install subversion git curl python3 gettext ncurses-bin libncurses5-dev git-core zlib1g-dev libssl-dev python2.7 unzip gawk zlib1g-dev
+wget -c https://gitlab.labs.nic.cz/turris/openwrt/uploads/0673001b14ab1d1769604ff0ce7d8781/git-version-check-fix.patch